﻿open System
open System.Collections.Generic
open System.IO
open System.Linq
open System.Net
open System.Text

let baseUrl = "http://ichart.finance.yahoo.com/table.csv?s="
let fetch (startDate:DateTime) (endDate:DateTime) symbol =
   let query = String.Format("&a={0}&b={1}&c={2}&d={3}&e={4}&f={5}&g=d&ignore=.csv", startDate.Month - 1, startDate.Day, startDate.Year, endDate.Month - 1, endDate.Day, endDate.Year)
   let url = baseUrl + symbol + query
   let request = WebRequest.Create(url)
   use response = request.GetResponse()
   use reader = new StreamReader(response.GetResponseStream(), Encoding.ASCII)
   reader.ReadToEnd()

let Main =
   Console.WriteLine("Welcome")

   Console.WriteLine("Enter Stock Symbol")
   let symbol = Console.ReadLine()

   Console.WriteLine("Enter start date (yyyy/mm/dd)")
   let startDate = DateTime.Parse(Console.ReadLine())

   Console.WriteLine("Enter end date (yyyy/mm/dd)")
   let endDate = DateTime.Parse(Console.ReadLine())

   let result = fetch startDate endDate symbol
   let cleanup (result:string) = 
      let lines = result.Split((char)10)
      [
         for i in 1 .. lines.Length - 1 do
            yield lines.[i]
      ]  
   
   cleanup result |> List.rev |> List.iter Console.WriteLine 

   let waitToClose = Console.ReadLine()
   ()